<template>
  <div>
    <v-row>
      <v-col cols="12">
        <gmap-map
          :center="center"
          :zoom="15"
          style="width: 100%; height: 400px"
          @click="mark"
        >
          <gmap-marker
            :key="index"
            v-for="(m, index) in markers"
            :position="m.position"
            @click="center = m.position"
            :clickable="true"
          >
          </gmap-marker>
        </gmap-map>
      </v-col>
      <v-col cols="12"><AutoCompleteMap @addMarker="addMarker" /></v-col>
      <v-col cols="12"> <LocationForm :obj="obj" /></v-col>
    </v-row>
  </div>
</template>

<script>
import AutoCompleteMap from "./AutoCompleteMap";
import LocationForm from "./LocationForm";
import { gmapApi } from "vue2-google-maps";
import { GoogleService } from "./google_service/index";
export default {
  data() {
    return {
      center: { lat: 13.736717, lng: 100.523186 },
      markers: [],
      items: [],
      obj: {},
      places: [],
      currentPlace: null,
    };
  },
  components: {
    AutoCompleteMap,
    LocationForm,
  },
  computed: { google: gmapApi },
  created() {
    this.geolocate();
    this.$gmapApiPromiseLazy().then(() => {
      if (this.google) {
        this.geocoder = new this.google.maps.Geocoder();
      }
      this.markers = [];
      const marker = {
        lat: this.center.lat,
        lng: this.center.lng,
      };
      this.markers.push({ position: marker });
    });
  },
  methods: {
    mark(event) {
      this.markers = [];
      const marker = {
        lat: event.latLng.lat(),
        lng: event.latLng.lng(),
      };
      this.markers.push({ position: marker });
      this.center = marker;
      this.geocoder.geocode({ location: marker }, (results) => {
        let res = GoogleService.googleResult(results, undefined);
        this.obj = res;
      });
    },
    addMarker(currentPlace) {
      this.markers = [];
      const marker = {
        lat: currentPlace.latitude,
        lng: currentPlace.longtitude,
      };
      this.markers.push({ position: marker });
      this.center = marker;
      this.obj = currentPlace;
    },
    geolocate() {
      navigator.geolocation.getCurrentPosition((position) => {
        this.center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude,
        };
        this.markers.push({ position: this.center });
      });
    },
  },
};
</script>